extends Node2D




func _ready():
	
	
	var but1 = MenuButton.new()
	prepare_popup_button(but1)
	but1.text = "button1"
	but1.rect_position = Vector2(100,0)
	
	var but2 = MenuButton.new()
	prepare_popup_button(but2)
	but2.text = "button2"
	but2.rect_position = Vector2(300,0)
	
	await wait_idle_frames(100)
	
	print("pressing 1st button")
	await realistic_lclick(center(but1))
	await wait_idle_frames(20)
	
	print("pressing 2nd button")
	await realistic_lclick(center(but2))
	await wait_idle_frames(20)
	
	assert(but1.get_popup().visible == false,\
				"first popup remains open. FAILURE")
	assert(but2.get_popup().visible == true,\
				"second popup gets hidden. FAILURE")

func center(control):
	return (control.get_rect().position + control.get_rect().end)/2

func realistic_lclick(vector2):
	
	var press_ev = InputEventMouseButton.new()
	press_ev.pressed = true
	press_ev.button_index = MOUSE_BUTTON_LEFT
	press_ev.button_mask = MOUSE_BUTTON_MASK_LEFT
	press_ev.position = vector2
	
	print("input - parsing press")
	Input.parse_input_event(press_ev)
	
	await wait_idle_frames(20)
	
	var release_ev = InputEventMouseButton.new()
	release_ev.pressed = false
	release_ev.button_index = MOUSE_BUTTON_LEFT
	release_ev.button_mask = MOUSE_BUTTON_MASK_LEFT
	release_ev.position = vector2
	
	print ("input - parsing release")
	Input.parse_input_event(release_ev)

func wait_idle_frames(n):
	for i in range(n):
		await get_tree().process_frame

func prepare_popup_button(popup_button):
	popup_button.text = "TEST BUTTON"
	var submenu = PopupMenu.new()
	submenu.set_name("submenu")
	submenu.add_item("submenu item")
	popup_button.get_popup().add_child(submenu)
	popup_button.get_popup().add_submenu_item("submenu label","submenu")
	add_child(popup_button)
